# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

from ..core.datetime_utils import serialize_datetime
from .vertex_embedding_mode import VertexEmbeddingMode

try:
    import pydantic
    if pydantic.__version__.startswith("1."):
        raise ImportError
    import pydantic.v1 as pydantic  # type: ignore
except ImportError:
    import pydantic  # type: ignore


class ExtendVertexTextEmbedding(pydantic.BaseModel):
    """
    Base class for embeddings.
    """

    model_name: typing.Optional[str] = pydantic.Field(description="The name of the embedding model.")
    embed_batch_size: typing.Optional[int] = pydantic.Field(description="The batch size for embedding calls.")
    callback_manager: typing.Optional[typing.Dict[str, typing.Any]]
    num_workers: typing.Optional[int] = pydantic.Field(
        description="The number of workers to use for async embedding calls."
    )
    embed_mode: VertexEmbeddingMode = pydantic.Field(description="The embedding mode to use.")
    additional_kwargs: typing.Optional[typing.Dict[str, typing.Any]] = pydantic.Field(
        description="Additional kwargs for the Vertex."
    )
    client_email: typing.Optional[str] = pydantic.Field(
        description="The client email to use when making Vertex API calls."
    )
    token_uri: typing.Optional[str] = pydantic.Field(description="The token uri to use when making Vertex API calls.")
    private_key_id: typing.Optional[str] = pydantic.Field(
        description="The private key id to use when making Vertex API calls."
    )
    private_key: typing.Optional[str] = pydantic.Field(
        description="The private key to use when making Vertex API calls."
    )
    project: str = pydantic.Field(description="The default GCP project to use when making Vertex API calls.")
    location: str = pydantic.Field(description="The default location to use when making API calls.")
    class_name: typing.Optional[str]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
